//******************************************
//  ƣ MQ6832_TC0_12Bit
//  汾     V 1.00
//       TC00 TC01 12Bit PWM ʹú
//  ע    
//******************************************

#include "main.h"

//*********************************************************************
//    : T001_12BitPWM_Init
//  : T001_12BitPWM ʼʽ
// ע     :
//*********************************************************************
void T001_12BitPWM_Init(void)
{
//====== ܽųʼ ======
    P7DR_P1 = 1;                        // ݔ_rݔֵ, hͬPWMĳʼֵ(T0xMOD_TFF)
    P7CR_P1 = 1;                        // _Oݔ

//====== ܿ( Enable) ======
    POFFCR0_TC001EN = 1;                // @_, PO

//====== 趨 ======
    T001CR_TCAS     = 1;                // x񌢃ɂ8λMӋrMʹ
    T01MOD_TFF      = 1;                // Oʼֵߜλռձ
//	PxFC ùţڳʼֵ趨֮ PxFC
    P7FC_P1         = 1;                // _OPWM

    T01MOD_DBE      = 1;                // ʹp
    T01MOD_TCK      = 5;                // fcgck/4 = 4MHz,L, PWMݔlʞ4MHz/256 = 15.625KHz, Lڞ64uS
                                        // ռձӋLڞ16*64us = 1024us
    T01MOD_TCM      = 2;                // OPWMģʽ
    T00PWM          = 0x04;             // Oռձȵĵ8λ
    T01PWM          = 0x04;             // Oռձȵĸ8λ
                                        // 0.25us*(0x404) = 257/1024 = , ռձȞ25.098%
    NOP;                                // ָ
}


//*********************************************************************
//    : T001_12BitPWM_Start
//  : T001_12BitPWM 
// ע     :
//*********************************************************************
void T001_12BitPWM_Start(void)
{
    T001CR_T01RUN = 1;
}


//*********************************************************************
//    : T001_12BitPWM_Stop
//  : T001_12BitPWM ֹͣ
// ע     :
//*********************************************************************
void T001_12BitPWM_Stop(void)
{
    T001CR_T01RUN = 0;
}


//*********************************************************************
//    : T001_12BitPWM_IntEnable
//  : TC01 ж
// ע     : ִкῪж(IMF)
//*********************************************************************
void T001_12BitPWM_IntEnable(void)
{
    DI;                                 // ֹпж // EIRL_IMF=0
    IL_INTTC01 = 0;                     // ж
    EI_INTTC01 = 1;                     // 趨ж
    EI;                                 // пж // EIRL_IMF=1
}

//*********************************************************************
//    : T001_12BitPWM_IntDisable
//  : TC01 жϳ
// ע     : ִкῪж(IMF)
//*********************************************************************
void T001_12BitPWM_IntDisable(void)
{
    DI;                                 // ֹпж // EIRL_IMF=0
    EI_INTTC01 = 0;                     // ж
    IL_INTTC01 = 0;                     // ж
    EI;                                 // пж // EIRL_IMF=1
}


//*********************************************************************
//    : T001_12BitPWM_SetDuty
//  : Oռձȣռձ= pwmDuty/4096
// ע     :  0 <= pwmDuty <=4095
//*********************************************************************
void T001_12BitPWM_SetDuty(uint pwmDuty)
{
    pwmDuty &= 0xfff;                   // ֻ12λЧ
    T00PWM = pwmDuty&0xff;              // Oλ
    T01PWM = (pwmDuty&0xf00)>>8;        // Oλ
}

//*********************************************************************
//    : IntTC01
//  : TC01 жϸʽ
// ע     :
//*********************************************************************
void __interrupt IntTC01(void)
{
    NOP;                                // ָ
}


























